var base_url;
var custom_language = {
    zh_CN:{
        default_query : "查询条件",
        default_year : "年",
        default_month: "月",
        default_consume : "消耗",
        default_document: "本单据",
        default_sure : "确定",
        default_cancel : "取消"
    },
    en_US:{
        default_query : "Query criteria",
        default_year : "Year",
        default_month: "Month",
        default_consume : "consumption",
        default_document: "This document",
        default_sure : "Confirm",
        default_cancel : "Cancel",
        month_desc_1 : "Jan.",
        month_desc_2 : "Feb.",
        month_desc_3 : "Mar.",
        month_desc_4 : "Apr.",
        month_desc_5 : "May",
        month_desc_6 : "Jun.",
        month_desc_7 : "Jul.",
        month_desc_8 : "Aug.",
        month_desc_9 : "Sept.",
        month_desc_10 : "Oct.",
        month_desc_11 : "Nov.",
        month_desc_12 : "Dec.",
        month_desc_all_1 : "January",
        month_desc_all_2 : "February",
        month_desc_all_3 : "March",
        month_desc_all_4 : "April",
        month_desc_all_5 : "May",
        month_desc_all_6 : "June",
        month_desc_all_7 : "July",
        month_desc_all_8 : "August",
        month_desc_all_9 : "September",
        month_desc_all_10 : "October",
        month_desc_all_11 : "November",
        month_desc_all_12 : "December"
    }
}
/**
 * 语言类型,nuem
 * @type {{zh: string, en: string, jp: string}}
 */
var custom_language_type = {
    zh : "zh_CN",
    en : "en_US",
    jp:  "JP"
}

/**
 *
 * 获取URL链接中的值
 * @param key url中的KEY
 * @returns {string}
 * @constructor
 */
function GetQueryString(key) {
    var reg = new RegExp("(^|&)" + key + "=([^&]*)(&|$)", "i");
    var arr = window.location.search.substr(1).match(reg);  //获取url中"?"符后的字符串并正则匹配
    var context = "";
    if (arr != null){
        context = arr[2];
    }
    reg = null;
    arr = null;
    return context == null || context == "" || context == "undefined" ? "" : context;
}

/**
 * 从一个数组中知道最大值或者最小值
 * @param arr 数字数组
 * @param maximin max/min
 * @returns {*}
 */
function getMaximin(arr,maximin){
    if(maximin=="max"){
        return Math.max.apply(Math,arr);
    }else if(maximin=="min"){
        return Math.min.apply(Math, arr);
    }
}

/**
 * 从服务器端获取业务数据
 * @param dateStr
 */
function postData(dateStr){
    var startDate = new Date().getTime();
    base_url =  removeHtmlTabAndContent(GetQueryString("api_server"));
    console.info("api_server:"+base_url);
    var localeStr = removeHtmlTabAndContent(GetQueryString("locale")) || "zh_CN";
    var pathIdStr = removeHtmlTabAndContent(GetQueryString("path_id"));
    var tokenStr = removeHtmlTabAndContent(GetQueryString("token"));
    if(dateStr == undefined || dateStr == ""
        || localeStr == undefined || localeStr == ""
        || pathIdStr == undefined || pathIdStr == ""
        || tokenStr == undefined || tokenStr == ""){
        return;
    }

    var dateStrArray = dateStr.split("-");
    //设置显示的值
    var displayDateText = "";
    //这里是为了去掉月份小于10前面的0
    var tempMonthDesc = "";
    if(dateStrArray[1] < 10 && dateStrArray[1].length ==2){
        tempMonthDesc = dateStrArray[1].substring(1);
    }else{
        tempMonthDesc = dateStrArray[1];
    }
    if(localeStr == custom_language_type.zh){
        displayDateText = dateStrArray[0] + custom_language.zh_CN.default_year + "、" + tempMonthDesc +  custom_language.zh_CN.default_month;
    }else if(localeStr == custom_language_type.en){
        tempMonthDesc= getEnglishText(tempMonthDesc,"simple");
        displayDateText = dateStrArray[0] + " , " + tempMonthDesc;
    }else{
        displayDateText = dateStrArray[0] + custom_language.zh_CN.default_year + "、" + tempMonthDesc +  custom_language.zh_CN.default_month;
    }
    $("#searchDateID").text(displayDateText);

    $.ajax({
        url: base_url + "/api/v1/query?locale="+localeStr,
        data: JSON.stringify({
            type:'exp_approve_expense_summary',
            input: JSON.stringify({path_id:pathIdStr,year:dateStrArray[0],month:dateStrArray[1]})
        }),
        method: "POST",
        dataType:"json",
        beforeSend: function(request){
            request.setRequestHeader("Authorization","Bearer " + tokenStr);
        },
        crossDomain: true,
        contentType:'application/json; charset=UTF-8',
        success: function(data){
            //解析返回值
            if(data != null || data != undefined){
                var document = $("#container");
                document.empty();
                if(data.length == 0){
                    noDataOrErrorShowPage(true);
                    return ;
                }
                //先转成字符串,作用于将里面的HTML标签去掉，目的防止注入
                var temDataStr = JSON.stringify(data);
                var dataArray = JSON.parse(removeHtmlTabAndContent(temDataStr));
                //翻译
                var consumeYearLanguage = "";
                var consumeMonthLanguage = "";
                var consumeDocumentLanguage = "";
                var displayYearConsume = "";
                var displayMonthConsume = "";
                var displayDocumentConsume = "";
                if(localeStr == custom_language_type.zh){
                    consumeYearLanguage = custom_language.zh_CN.default_year + custom_language.zh_CN.default_consume;
                    consumeMonthLanguage = custom_language.zh_CN.default_month + custom_language.zh_CN.default_consume;
                    consumeDocumentLanguage = custom_language.zh_CN.default_document + custom_language.zh_CN.default_consume;
                    displayYearConsume = dateStrArray[0]  + consumeYearLanguage;
                    displayMonthConsume = tempMonthDesc + consumeMonthLanguage;
                }else if(localeStr == custom_language_type.en){
                    consumeYearLanguage = custom_language.en_US.default_consume;
                    consumeMonthLanguage = custom_language.en_US.default_consume;
                    consumeDocumentLanguage = custom_language.en_US.default_document + " " + custom_language.en_US.default_consume;
                    displayYearConsume = dateStrArray[0] + " " + consumeYearLanguage;
                    //翻译标签月份,重新初始变量
                    if(dateStrArray[1] < 10 && dateStrArray[1].length ==2){
                        tempMonthDesc = dateStrArray[1].substring(1);
                    }else{
                        tempMonthDesc = dateStrArray[1];
                    }
                    tempMonthDesc= getEnglishText(tempMonthDesc,"all");
                    displayMonthConsume = tempMonthDesc + " " + consumeMonthLanguage;
                }else{
                    consumeYearLanguage = custom_language.zh_CN.default_year + custom_language.zh_CN.default_consume;
                    consumeMonthLanguage = custom_language.zh_CN.default_month + custom_language.zh_CN.default_consume;
                    consumeDocumentLanguage = custom_language.zh_CN.default_document + custom_language.zh_CN.default_consume;
                    displayYearConsume = dateStrArray[0] + consumeYearLanguage;
                    displayMonthConsume = tempMonthDesc + consumeMonthLanguage;
                }
                var displayDocumentConsume = consumeDocumentLanguage;
                //循环组装HTML页面
                var childHtml = "";
                for(var i=0;i<dataArray.length;i++){
                    var dataItem = dataArray[i];

                    var numberArray=[];
                    var yearAmount = dataItem.year_amount || 0;
                    numberArray.push(yearAmount);
                    var monthAmount = dataItem.month_amount || 0;
                    numberArray.push(monthAmount);
                    var claimAmount = dataItem.claim_amount || 0;
                    numberArray.push(claimAmount);
                    var maxAmount = getMaximin(numberArray,"max");
                    //Year
                    var yearProgress = "0%";
                    //Month
                    var monthProgress = "0%";
                    //Claim
                    var claimProgress = "0%";
                    if(maxAmount <= 0){
                        yearProgress = "100%";
                        monthProgress = "100%";
                        claimProgress = "100%";
                    }else{
                        yearProgress = Math.ceil(yearAmount / maxAmount * 100) + "%";
                        monthProgress = Math.ceil(monthAmount / maxAmount * 100 ) + "%";
                        claimProgress = Math.ceil(claimAmount / maxAmount * 100 ) + "%";
                    }
                   //组装HTML页面
                    childHtml += "<div class=\"jack-hotel\">\n" +
                        "        <section class=\"aui-content-padded\">\n" +
                        "            <h4 class=\"jack-h4\">"+dataItem.type+"</h4>\n" +
                        "            <div class=\"aui-content jack-hotel-range\">\n" +
                        "                <section class=\"aui-content-padded jack-item-set\">\n" +
                        "                    <div class=\"userinfo-header\">\n" +
                        "                        <div class=\"aui-info\">\n" +
                        "                            <div class=\"aui-info-item\">\n" +
                        "                                <span class=\"aui-margin-l-10 aui-margin-r-10 jack-item-lable-set\">"+displayYearConsume+"</span>\n" +
                        "                            </div>\n" +
                        "                            <div class=\"aui-info-item jack-text-set\">"+formatNumberRgx(dataItem.year_amount)+"</div>\n" +
                        "                        </div>\n" +
                        "                        <div class=\"aui-progress aui-progress jack-progress-height\">\n" +
                        "                            <div class=\"aui-progress-bar jack-progress-height-color-2\" style=\"width: "+yearProgress+";\"></div>\n" +
                        "                        </div>\n" +
                        "                    </div>\n" +
                        "                    <div class=\"aui-card-list-content-padded\"></div>\n" +
                        "                </section>\n" +
                        "                <section class=\"aui-content-padded jack-item-set\">\n" +
                        "                    <div class=\"userinfo-header\">\n" +
                        "                        <div class=\"aui-info\">\n" +
                        "                            <div class=\"aui-info-item\">\n" +
                        "                                <span class=\"aui-margin-l-10 aui-margin-r-10 jack-item-lable-set\">"+displayMonthConsume+"</span>\n" +
                        "                            </div>\n" +
                        "                            <div class=\"aui-info-item jack-text-set\">"+formatNumberRgx(dataItem.month_amount)+"</div>\n" +
                        "                        </div>\n" +
                        "                        <div class=\"aui-progress aui-progress jack-progress-height\">\n" +
                        "                            <div class=\"aui-progress-bar jack-progress-height-color-1\" style=\"width: "+monthProgress+";\"></div>\n" +
                        "                        </div>\n" +
                        "                    </div>\n" +
                        "                    <div class=\"aui-card-list-content-padded\"></div>\n" +
                        "                </section>\n" +
                        "                <section class=\"aui-content-padded jack-item-set\">\n" +
                        "                    <div class=\"userinfo-header\">\n" +
                        "                        <div class=\"aui-info\">\n" +
                        "                            <div class=\"aui-info-item\">\n" +
                        "                                <span class=\"aui-margin-l-10 aui-margin-r-10 jack-item-lable-set\">"+displayDocumentConsume+"</span>\n" +
                        "                            </div>\n" +
                        "                            <div class=\"aui-info-item jack-text-set\">"+formatNumberRgx(dataItem.claim_amount)+"</div>\n" +
                        "                        </div>\n" +
                        "                        <div class=\"aui-progress aui-progress jack-progress-height\">\n" +
                        "                            <div class=\"aui-progress-bar jack-progress-height-color-1\" style=\"width: "+claimProgress+";\"></div>\n" +
                        "                        </div>\n" +
                        "                    </div>\n" +
                        "                    <div class=\"aui-card-list-content-padded\"></div>\n" +
                        "                </section>\n" +
                        "            </div>\n" +
                        "        </section>\n" +
                        "    </div>";
                }
                document.append(childHtml);
                var endDate = new Date().getTime();
                //console.info("响应速度:"+endDate - startDate);
            }else{
                //服务器返回数据为空
            }
        },
        error: function(error){
            console.info("error");
            noDataOrErrorShowPage(false);
        }
    })
};

/**
 *
 * @param document
 * @param isOk true表示没有数据/false表示error
 */
function noDataOrErrorShowPage(isOk){
    var showHtml = "";
    if(isOk){
        showHtml = "<div class='aui-content'><span class='aui-text-center jack-center'><i class=\"aui-iconfont aui-icon-info jack-icon\"></i>  暂无数据</span></div>";
    }else{
        showHtml = "<div class='aui-content'><span class='aui-text-center jack-center'><i class=\"aui-iconfont aui-icon-info jack-icon\"></i>  数据加载异常</span></div>";
    }
    var document = $("#container");
    document.append(showHtml)
}

/**
 * 传入月份翻译成英文
 * @param tempMonthDesc
 * @param flag simple/all
 * @returns {*}
 */
function getEnglishText(tempMonthDesc,flag){
    if(tempMonthDesc == 1){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_1 : custom_language.en_US.month_desc_1;
    }else if(tempMonthDesc == 2){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_2 : custom_language.en_US.month_desc_2;
    }else if(tempMonthDesc == 3){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_3 : custom_language.en_US.month_desc_3;
    }else if(tempMonthDesc == 4){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_4 : custom_language.en_US.month_desc_4;
    }else if(tempMonthDesc == 5){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_5 : custom_language.en_US.month_desc_5;
    }else if(tempMonthDesc == 6){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_6 : custom_language.en_US.month_desc_6;
    }else if(tempMonthDesc == 7){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_7 : custom_language.en_US.month_desc_7;
    }else if(tempMonthDesc == 8){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_8 : custom_language.en_US.month_desc_8;
    }else if(tempMonthDesc == 9){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_9 : custom_language.en_US.month_desc_9;
    }else if(tempMonthDesc == 10){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_10 : custom_language.en_US.month_desc_10;
    }else if(tempMonthDesc == 11){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_11 : custom_language.en_US.month_desc_11;
    }else if(tempMonthDesc == 12){
        tempMonthDesc = (flag == "all") ? custom_language.en_US.month_desc_all_12 : custom_language.en_US.month_desc_12;
    }
    return tempMonthDesc;
}

/**
 * 格式化数据12345，成123,45
 * @param num
 * @returns {*}
 */
function formatNumberRgx(num) {
    if(isNaN(num)){
        return 0;
    }
    var parts = num.toString().split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    return parts.join(".");
};


/**
 * 删除掉所有的HTML标签和标签之间的内容,
 * 注意数据不要用<>符号包裹
 * @param value
 * @returns {string|XML|void}
 */
function removeHtmlTabAndContent(value) {
    return value.replace(/<.+?>.+?<\/?.+?>/g,'');
}
